﻿@page "/outbound/scanner/{BatchId:int}"

@inject HttpClient WebClient
@inject IJSRuntime JSRuntime
@inject ISnackbar Snackbar
@inject IDialogService DialogService
@inject NavigationManager NavigationManager
@using System.Text.Json.Serialization;
@using System.Text.Json;

@using SwP.Fulfillment.ParcelLogger.Shared


<style>
  


    .scanned {
        background-color: #81C784 !important;
    }

    .scanned-dark {
        background-color: #66BB6A !important;
    }
    
    .scanned > td,
    .scanned-dark > td {
        color: white !important;
    }
    
    .scanner > td .mud-input,
    .scanned-dark > td .mud-input {
                color: white !important;
    }
</style>

<PageTitle>Scan</PageTitle>

<MudStack>
    <MudContainer Class="mt-16" MaxWidth="MaxWidth.Medium">

    <MudItem xs="12" sm="12" md="12">
        @* <MudFocusTrap DefaultFocus="DefaultFocus.FirstChild"> *@
        <MudTextField @ref="_textInput" @bind-Value="_barcode" @onkeyup="@Enter"
                      Label="Barcode"
                        AutoFocus
                        OnlyValidateIfDirty
                       Variant="Variant.Outlined"
                        Required
                        Immediate
                       RequiredError="Cannot be empty!"
                       Validation="@(new Func<string, IEnumerable<string>>(Check))" />
         @*  </MudFocusTrap> *@
     </MudItem>

     <MudItem xs="12" Class="d-flex justify-center">
         <MudButton Variant="Variant.Filled" DisableElevation="true" Color="Color.Primary" Size="Size.Large" Class="mt-8" OnClick="@(async () => await SubmitAsync())">Submit</MudButton>
     </MudItem>

     <MudGrid Spacing="6" Class="mt-16">
         @if (_batch != null && _batch.Records != null)
        {
            var counter = _batch.Records.Count();
            <MudItem xs="12">
                <MudTable Items="@_batch.Records.OrderByDescending(x => x.Id)" Hover
                           Breakpoint="Breakpoint.None"
                           Loading="@_loadingOrSaving"
                           LoadingProgressColor="Color.Info"
                           RowClassFunc="@RowClassFunc"
                           OnRowClick="@(async (TableRowClickEventArgs<Record> x) => { await RowClickEvent(x); })">
                     <HeaderContent>
                         <MudTh>Nr</MudTh>
                         <MudTh>Scanned</MudTh>
                         <MudTh>Barcode1</MudTh>
                         <MudTh>Barcode2</MudTh>
                         <MudTh>Barcode3</MudTh>
                         
                     </HeaderContent>
                     <RowTemplate>
                         <MudTd HideSmall DataLabel="Nr">@(counter--)</MudTd>
                         <MudTd DataLabel="Scanned">
                                @if (context.DateReceivedToSent != null)
                            {
                                <MudIcon Icon="@Icons.Material.Filled.Check"  />
                            }
                         </MudTd>
                         <MudTd DataLabel="Barcode">@context.Barcode</MudTd>
                         <MudTd DataLabel="Barcode">@context.Barcode2</MudTd>
                         <MudTd HideSmall DataLabel="Barcode">@context.Barcode3</MudTd>
                    </RowTemplate>
                </MudTable>
            </MudItem>
        }
        else
        {
            <MudItem xs="12">
                <MudContainer Class="d-flex justify-center align-center" MaxWidth="MaxWidth.Medium">
                    <MudProgressCircular Color="Color.Default" Indeterminate="true" />
                </MudContainer>
            </MudItem>

        }
    </MudGrid>
</MudContainer>

    <MudContainer Class="d-flex justify-center align-center" MaxWidth="MaxWidth.Medium">
        <Animation AnimationNameSelect="fade-in">
            <MudFab Color="Color.Primary" StartIcon="@Icons.Material.Filled.Save" Size="Size.Large" OnClick="FlagAsComplete"></MudFab>
        </Animation>
    </MudContainer>
</MudStack>
<MudOverlay Visible="_loadingOrSaving" DarkBackground="true" Absolute="true">
    <MudProgressCircular Color="Color.Secondary" Indeterminate="true" />
</MudOverlay>


@code {

    [Parameter]
    public int BatchId { get; set; }

    bool _loadingOrSaving = true;

    string _barcode = "";
    OutboundList _batch = new();
    //Record _record = new();

    string _outboundsEndpointUrl = "api/outbounds/";
    string _recordsEndpointUrl = "api/records/";


    MudTextField<string> _textInput;

    //System.Globalization.CultureInfo _cultureInfo = System.Globalization.CultureInfo.GetCultureInfo("sk-SK");


    protected override async Task OnInitializedAsync()
    {

        await FetchData();
        //mark it as edited
        if (!_batch.Edited)
        {
            _batch.Edited = true;
            await WebClient.PutAsJsonAsync($"{_outboundsEndpointUrl}{_batch.Id}", _batch); // Adjust the API endpoint URL
        }

        _loadingOrSaving = false;
    }

    protected override void OnInitialized()
    {
        base.OnInitialized();

    }

    private string ErrorMessage = "";
    private bool Valid = false;

    public async Task Enter(KeyboardEventArgs e)
    {

        if (e.Code == "Enter" || e.Code == "NumpadEnter" || e.Key == "Enter")
        {
            await SubmitAsync();
        }
    }

    private IEnumerable<string> Check(string bar)
    {
        if (string.IsNullOrWhiteSpace(bar))
        {
            yield return "Barcode is required!";
            yield break;
        }
        if (bar.Length < 5)
            yield return "Barcode must be at least of length 5";

        if (bar.Length > 50)
            yield return "Barcode maximum length is 50";
        // if (_batch.Records.Any(x => x.Barcode == bar))
        //     yield return "This barcode already exists in the list";
    }

    private async Task SubmitAsync()
    {
        try
        {
            if (!IsValidBarcode(_barcode, out var matchingRecord))
            {
                ShowErrorMessage("Record is not valid. Please try again.");
                return;
            }
            if (matchingRecord != null)
            {
                if (matchingRecord.DateReceivedToSent != null)
                {
                    ShowErrorMessage("Item with this barcode was already scanned");
                    return;
                }


                matchingRecord.DateReceivedToSent = DateTime.Now; 
                var response = await WebClient.PutAsJsonAsync("api/outbounds/" + _batch.Id, _batch);

                if (!response.IsSuccessStatusCode)
                {
                    ShowErrorMessage($"Error code {response.StatusCode} returned from server.");
                    return;
                }
                await CheckCompletion();
                await FetchData();                

            }
            else
            {
                ShowErrorMessage("Record with this barcode not found!");
                return;
            }
            _barcode = "";
            await _textInput.FocusAsync();


        }
        catch (HttpRequestException ex)
        {
            ShowErrorMessage("Failed to save record. Please try again.");
        }

    }

    private async Task FetchData()
    {
        _batch = await WebClient.GetFromJsonAsync<OutboundList>("api/outbounds/" + BatchId, new JsonSerializerOptions() { ReferenceHandler = ReferenceHandler.IgnoreCycles });
    }
    private async Task CheckCompletion()
    {
        if(_batch.Records.Any(x => x.DateReceivedToSent == null))
        {
            return;    
        }

        var parameters = new DialogParameters<Dialog_FinishScanning>();
        parameters.Add(x => x.Content, "All records scanned");
        var dialog = await DialogService.ShowAsync<Dialog_FinishScanning>("", new DialogOptions() { Position = DialogPosition.TopCenter });
        var result = await dialog.Result;
        if (!result.Canceled)
        {
            _batch.Edited = false;
            _batch.Locked = true;
            var response = await WebClient.PutAsJsonAsync("api/outbounds/" + _batch.Id, _batch);

            if (!response.IsSuccessStatusCode)
            {
                ShowErrorMessage($"Error code {response.StatusCode} returned from server.");
                return;
            }
            NavigationManager.NavigateTo($"./outbound/", true);

        }
    }
    private async Task FlagAsComplete()
    {
        if (_batch.Records.Any(x => x.DateReceivedToSent == null))
        {
            return;
        }

        var parameters = new DialogParameters<Dialog_FinishScanning>();
        parameters.Add(x => x.Content, "All records scanned. Lock this scanning list?");
        var dialog = await DialogService.ShowAsync<Dialog_FinishScanning>("Completed", new DialogOptions() { Position = DialogPosition.TopCenter });
        var result = await dialog.Result;
        if (!result.Canceled)
        {
            _batch.Edited = false;
            _batch.Locked = true;
            var response = await WebClient.PutAsJsonAsync("api/outbounds/" + _batch.Id, _batch);

            if (!response.IsSuccessStatusCode)
            {
                ShowErrorMessage($"Error code {response.StatusCode} returned from server.");
                return;
            }
            NavigationManager.NavigateTo($"./outbound/", true);

        }
    }
    private bool IsValidBarcode(string barcode, out Record matchingRecord)
    {
        matchingRecord = _batch.Records
            .FirstOrDefault(rec =>
                rec.Barcode?.ToLower() == barcode.ToLower() ||
                rec.Barcode2?.ToLower() == barcode.ToLower() ||
                rec.Barcode3?.ToLower() == barcode.ToLower());

        return barcode.Length > 4 && barcode.Length < 50;
    }

    private void ShowErrorMessage(string message)
    {
        ErrorMessage = message;
        Snackbar.Clear();
        Snackbar.Configuration.PositionClass = Defaults.Classes.Position.BottomCenter;
        Snackbar.Add(ErrorMessage, Severity.Error);
    }

    void HandleIntervalElapsed(string debouncedText)
    {
        if (_batch.Records.Any(x => x.Barcode == debouncedText))
        {
            //SelectedIcon = Icons.Outlined.ErrorOutline;
            //SelectedColor = Color.Error;
        }
    }


    private string RowClassFunc(Record r, int rowNumber)
    {
        if (r.DateReceivedToSent != null)
        {
            if (rowNumber % 2 == 0)
                return "scanned-dark";
            else
                return "scanned";
        }
        return string.Empty;

    }
    async Task RowClickEvent(TableRowClickEventArgs<Record> row)
    {
        var isScanned = row.Item.DateReceivedToSent != null;

        var parameters = new DialogParameters<DeleteDialog>();
        if(isScanned)
        {
            parameters.Add(x => x.ContentText, $"Do you really want to flag this record as not scanned?");
            parameters.Add(x => x.ButtonText, "Unflag");
        }
        else
        {
            parameters.Add(x => x.ContentText, $"Do you really want manually flag this record as scanned?");
            parameters.Add(x => x.ButtonText, "Flag");

        }
        parameters.Add(x => x.Color, Color.Error);

        var options = new DialogOptions() { CloseButton = true, MaxWidth = MaxWidth.ExtraSmall };

        var dialog = DialogService.Show<DeleteDialog>("Question?", parameters, options);
        var result = await dialog.Result;

        if (!result.Canceled)
        {
            try
            {
                var record = _batch.Records.First(x => x.Id == row.Item.Id);
                record.DateReceivedToSent = isScanned ? null : DateTime.Now;
                _loadingOrSaving = true;
                StateHasChanged();

                var response = await WebClient.PutAsJsonAsync("api/outbounds/" + _batch.Id, _batch);
                if (!response.IsSuccessStatusCode)
                {
                    ShowErrorMessage($"Error code {response.StatusCode} returned from server.");
                }
                await FetchData();

                _loadingOrSaving = false;
                StateHasChanged();
            }
            catch (HttpRequestException ex)
            {
                ErrorMessage = "Failed to create record. Please try again.";
                Snackbar.Clear();
                Snackbar.Configuration.PositionClass = Defaults.Classes.Position.BottomCenter;
                Snackbar.Add(ErrorMessage, Severity.Error);
            }
        }
    }
}
